#!/usr/bin/env node

/**
 * Module dependencies.
 */
"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

require('source-map-support').install();

const debug = require('debug')('docsmith:init');

const program = require('commander');

const toYaml = require('js-yaml').safeDump;

const _require = require('./docsmith/utils/terminal'),
      banner = _require.banner,
      exit = _require.exit,
      promptConfirm = _require.promptConfirm,
      promptNew = _require.promptNew;

const settings = require('./docsmith/utils/settings');

const configure = require('./docsmith/configure');

const _require2 = require('./docsmith/store'),
      doNew = _require2.doNew,
      doLoad = _require2.doLoad;

let command;
program.arguments('[command]').option('-h, --help', 'Displays available commands.').action(function (cmd) {
  command = cmd;
}).parse(process.argv);
const help = program.help;

if (help) {
  console.log('config      : Same as config show');
  console.log('config show : Display current config');
  console.log('config init : Ensures configuration of current workspace is valid.'); // config set
  // config get

  exit();
} // ~~check if this is an empty folder.~~
// Check if the folder contains a folder for this instance.
// Also check if that instance is git initialise, and if not upgrade it.


const doNw = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* () {
    banner({
      title: 'Initialisation',
      message: 'This script will check your configuration and initialise the current directory as your workspace.' + '\n' + "Please answer a few questions below and you'll be up and running in no time" + '\n'
    }); // Loading without argument will prompt the user for the name of a new project and the name of a template.

    debug('non_interactive', non_interactive);
    const configuration = yield configure.doEnsure({
      non_interactive
    });
    debug('configuration', configuration);
    const templates = configuration.repository.instances[configuration.settings.instance].content.templates;
    debug('templates', templates);
    const default_template = Object.keys(templates)[0];
    debug('default_template', default_template);

    const _ref2 = yield promptNew({
      non_interactive,
      default_name: 'new',
      default_template,
      templates
    }),
          name = _ref2.name,
          template = _ref2.template,
          _ref2$branch = _ref2.branch,
          branch = _ref2$branch === void 0 ? configuration.user : _ref2$branch;

    const confirmed = yield promptConfirm({
      non_interactive
    });
    debug('confirmed', confirmed); // If the user confirms we create a new project

    const loaded = yield doNew({
      name,
      template,
      branch,
      configuration
    });
    debug('loaded', loaded);
  });

  return function doNw() {
    return _ref.apply(this, arguments);
  };
}();

doNw().catch(e => {
  exit('The new function terminated with an error.', e);
});
//# sourceMappingURL=docsmith-new.js.map