#!/usr/bin/env node

/**
 * Module dependencies.
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doConfigShow = exports.doConfigInit = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

require('source-map-support').install();

const debug = require('debug')('docsmith:init');

const program = require('commander');

const toYaml = require('js-yaml').safeDump;

const _require = require('./docsmith/utils/terminal'),
      banner = _require.banner,
      exit = _require.exit,
      promptConfirm = _require.promptConfirm,
      promptNew = _require.promptNew;

const settings = require('./docsmith/utils/settings');

const configure = require('./docsmith/configure');

let command;
program.arguments('[command]').option('-h, --help', 'Displays available commands.').action(function (cmd) {
  command = cmd;
}).parse(process.argv);
const help = program.help;

if (help) {
  console.log('config      : Same as config show');
  console.log('config show : Display current config');
  console.log('config init : Ensures configuration of current workspace is valid.'); // config set
  // config get

  exit();
} // ~~check if this is an empty folder.~~
// Check if the folder contains a folder for this instance.
// Also check if that instance is git initialise, and if not upgrade it.


const doConfigShow = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* () {
    const configuration = configure.get();

    if (configuration) {
      banner({
        title: 'Config',
        message: toYaml(configuration)
      });
    } else {
      banner({
        title: 'Config',
        message: 'No configuration found. Run `' + settings.instance + ' config init` or your workspace.' + '\n' + '\n'
      });
    }
  });

  return function doConfigShow() {
    return _ref.apply(this, arguments);
  };
}();

exports.doConfigShow = doConfigShow;

const doConfigInit = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(function* () {
    banner({
      title: 'Config',
      message: 'This script will initialise the current directory as your workspace.' + '\n' + '\n' + 'It will also update your global `.content` repository' + '\n' + 'and install the following content packages and their dependencies:' + '\n' + '\n' + // Object.keys(content.packages).map(repo => '\t' + repo + ': ' + content.packages[repo] + '\n') +
      '\n' + "Please answer a few questions below and you'll be up and running in no time" + '\n'
    }); // Loading without argument will prompt the user for the name of a new project
    // debug('non_interactive', non_interactive);
    // const { name, template } = await promptNew({ non_interactive, default_name: settings.user });
    //
    // const confirmed = await promptConfirm({ non_interactive });
    // debug('confirmed', confirmed);
    // And the name of a template.
    // const loaded = await doLoad();
    // debug('loaded', confirmed);
  });

  return function doConfigInit() {
    return _ref2.apply(this, arguments);
  };
}();

exports.doConfigInit = doConfigInit;

if (command === '' || command === 'show') {
  doConfigShow().catch(e => {
    exit('The show function terminated with an error.', e);
  });
} else if (command === 'init') {
  doConfigInit().catch(e => {
    exit('The init function terminated with an error.', e);
  });
}
//# sourceMappingURL=docsmith-save.js.map