"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doInit = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const debug = require('debug')('docsmith:init');

const _require = require('./utils/terminal'),
      banner = _require.banner,
      exit = _require.exit;

const configure = require('./configure');

const _require2 = require('./workspace'),
      doWorkspaceInit = _require2.doWorkspaceInit,
      doWorkspaceCheck = _require2.doWorkspaceCheck,
      doWorkspaceUpgrade = _require2.doWorkspaceUpgrade;

const settings = require('./utils/settings');

const doInit = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* ({
    non_interactive
  }) {
    banner({
      title: 'Initialisation',
      message: 'This script will check your configuration and initialise the current directory as your workspace.' + '\n' + "Please answer a few questions below and you'll be up and running in no time" + '\n'
    }); // Loading without argument will prompt the user for the name of a new project and the name of a template.

    debug('non_interactive', non_interactive); // const configuration = await configure.doEnsure({ non_interactive });

    let configuration = yield configure.doGet();
    debug('configuration', configuration);

    if (!configuration) {
      debug('configuration needs to be created');
      configuration = yield configure.doInit({
        non_interactive
      });
    } else {
      debug('configuration needs to be updated');
      configuration = yield configure.doInit({
        non_interactive,
        configuration
      });
    }

    debug('configuration', configuration);
    const workspace = yield doWorkspaceCheck({
      non_interactive: true,
      configuration,
      path: process.cwd()
    }); // Check if workspace is properly described in repository.workspace
    //   - If not, just update the workspace ? Or could this be a problem?

    if (!workspace) {
      debug('workspace needs to be initialised');
      configuration = yield doWorkspaceInit({
        non_interactive,
        configuration
      });
    } else {
      configuration = yield doWorkspaceUpgrade({
        non_interactive,
        configuration
      });
    } //
    // // Check if packages described in the repository config (possibly updated from the initial bootstrap config)
    // // Are present.
    // const pkgs = await doPackagesCheck({ non_interactive, configuration });
    // debug('pkgs', pkgs[settings.instance]);
    // const missing_pkgs = pkgs[settings.instance].filter(x => !x[Object.keys(x)[0]]).map(x => Object.keys(x)[0]);
    // debug('missing_pkgs', missing_pkgs);
    // if (missing_pkgs.length !== 0) {
    //   debug('initialising missing packages.');
    //   configuration = await doPackagesInit({ non_interactive, configuration, packages: missing_pkgs });
    // }
    //


    exit('Workspace succesfully initialised.');
  });

  return function doInit(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.doInit = doInit;
//# sourceMappingURL=init.js.map