"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doPackagesUpgrade = exports.doPackagesCheck = exports.doPackagesInit = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const debug = require('debug')('docsmith:package');

const fs = require('fs-extra');

const path = require('path');

global.Promise = require('bluebird');
global.Promise.promisifyAll(fs);

const _require = require('./utils/terminal'),
      exit = _require.exit;

const _require2 = require('./utils/git'),
      doClone = _require2.doClone,
      doPull = _require2.doPull;

const _require3 = require('./utils/npm'),
      taskInstall = _require3.taskInstall;

const _require4 = require('./instance'),
      doInstancesInfo = _require4.doInstancesInfo;

const legacy_packages = require('./init/packages');

const installPackages = ({
  pkgs,
  repository
}) => new global.Promise((resolve, reject) => legacy_packages.install({
  packages: pkgs,
  repository,
  link: false,
  verbose: true
}, (err, installed) => {
  if (err) return reject();
  resolve(installed);
})); // Verify is the packages declared in the content.yml file of the instance are installed in ~/.content/packages


const doPackagesCheck = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* ({
    non_interactive,
    configuration
  }) {
    return Promise.all(Object.keys(configuration.repository.instances).map( /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator(function* (instance) {
        console.trace();
        debug('instance', instance);
        return Promise.all(Object.keys(configuration.repository.instances[instance].content.packages).map( /*#__PURE__*/function () {
          var _ref3 = _asyncToGenerator(function* (pkg) {
            debug('path', path.join(configuration.settings.config.split('/content.yml')[0], 'packages', pkg, 'package.json'));
            return {
              [pkg]: yield fs.pathExistsAsync(path.join(configuration.settings.config.split('/content.yml')[0], 'packages', pkg, 'package.json'))
            };
          });

          return function (_x3) {
            return _ref3.apply(this, arguments);
          };
        }())).then(pkg => ({
          [instance]: pkg
        }));
      });

      return function (_x2) {
        return _ref2.apply(this, arguments);
      };
    }()));
  });

  return function doPackagesCheck(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.doPackagesCheck = doPackagesCheck;

const isLink = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator(function* (path) {
    try {
      const lstat = fs.lstatSync(path);
      return lstat.isSymbolicLink();
    } catch (e) {
      if (e.code == 'ENOENT') {
        return e;
      }

      process.exit();
    }
  });

  return function isLink(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

const isDir = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator(function* (path) {
    try {
      const stat = fs.statSync(path);
      return stat.isDirectory();
    } catch (e) {
      if (e.code == 'ENOENT') {
        return false;
      }

      process.exit();
    }
  });

  return function isDir(_x5) {
    return _ref5.apply(this, arguments);
  };
}();

const isGitDir = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator(function* (path) {
    try {
      const stat = fs.statSync(path);
      return stat.isDirectory() && fs.existsSync(path.join(path, '.git'));
    } catch (e) {
      if (e.code == 'ENOENT') {
        return false;
      }

      process.exit();
    }
  });

  return function isGitDir(_x6) {
    return _ref6.apply(this, arguments);
  };
}();

const toDir = path => isLink(path) ? fs.readlinkSync(path) : path;

const doPackagesUpgrade = /*#__PURE__*/function () {
  var _ref7 = _asyncToGenerator(function* ({
    non_interactive,
    configuration,
    packages
  }) {
    // Check if local or use npm to check on remote availability.
    // TODO: Think about linking
    // Check if https or git url.
    configuration.settings = require('./utils/settings').current();
    configuration.settings.package = configuration.settings.pkg;
    debug('configuration.settings', configuration.settings);
    debug('packages', packages);
    const commits = yield doPull(packages);
    debug('commits', commits);
    console.log('Cloned packages ', commits); // Error: Refusing to delete /Users/jun/.content/packages/activist-apprentice-course-template/node_modules/activist-apprentice-course-template/node_modules/.bin/esparse: containing path /Users/jun/dev/apprentice/workspace/node_modules/activist-apprentice-course-template/node_modules/esprima isn't under npm's control
    // TODO: Maybe delete node_modules and reinstall
    // const instances = await doInstancesInfo({ instances: configuration.repository.instances });
    //
    // const content_packages = instances[configuration.settings.instance].content.packages;
    // debug('content_packages', content_packages);
    //
    // // Install packages
    // const installed = await installPackages({
    //   pkgs: content_packages,
    //   repository: configuration.settings.config.replace('/content.yml', '')
    // });
    // debug('installed', installed);
    //
    // const installed_packages = await doInstancesInfo({ instances: configuration.repository.instances });
    // debug('installed_packages', installed_packages);
    // TODO: Check and Update symlinks.

    return configuration;
  });

  return function doPackagesUpgrade(_x7) {
    return _ref7.apply(this, arguments);
  };
}();

exports.doPackagesUpgrade = doPackagesUpgrade;

const doPackagesInit = /*#__PURE__*/function () {
  var _ref8 = _asyncToGenerator(function* ({
    non_interactive,
    configuration,
    packages,
    current
  }) {
    // Check if local or use npm to check on remote availability.
    // TODO: Think about linking
    // Check if https or git url.
    configuration.settings = require('./utils/settings').current();
    configuration.settings.package = configuration.settings.pkg;
    debug('configuration', configuration);
    debug('packages', packages); // Clone
    //
    // const links = Object.keys(packages)
    //   .filter(pkg => isLink(path.join(configuration.settings.packages, pkg)))
    //   .map(pkg => {
    //     debug('Package link already exists', pkg);
    //     return {
    //       pth: path.join(configuration.settings.packages, pkg),
    //       lnk: fs.readlinkSync(path.join(configuration.settings.packages, pkg))
    //     };
    //   });
    //
    // debug('links', links);
    //
    // const folders = Object.keys(packages)
    //   .filter(pkg => isLink(path.join(configuration.settings.packages, pkg)))
    //   .filter(pkg => isDir(path.join(configuration.settings.packages, pkg)))
    //   .map(pkg => {
    //     debug('Package folder already exists', pkg);
    //     return path.join(configuration.settings.packages, pkg);
    //   });
    //
    // debug('folders', folders);
    //
    // if (folders.length !== 0 || links.length !== 0) {
    //   // TODO: More granular checking and propose to update to .git folder, display version...
    //   exit(
    //     'The following packages have already been initialised. Please try to update instead of initialising:\n' +
    //       folders.concat(links.map(({ lnk, pth }) => pth + ' -> ' + lnk)).map(repo => '  - ' + repo + '\n')
    //   );
    // }
    //
    // const reposLinks = links.filter(({ lnk }) => isGitDir(lnk)).map(link => {
    //   debug('Package link is already a git repository', link);
    //   return link;
    // });
    //
    // debug('reposLinks', reposLinks);
    //
    // const reposFolders = folders.filter(pth => isGitDir(pth)).map(pth => {
    //   debug('Package folder is already a git repository', pth);
    //   return pth;
    // });
    //
    // debug('reposFolders', reposFolders);
    //
    // if (reposFolders.length !== 0 || reposLinks.length !== 0) {
    //   // TODO: More granular checking and propose to update to .git folder
    //   exit(
    //     'The following packages have already been initialised and have .git folders. Please try to update instead of initialising:\n' +
    //       reposFolders.concat(reposLinks.map(({ lnk, pth }) => pth + ' -> ' + lnk)).map(repo => '  - ' + repo + '\n')
    //   );
    // }

    const uninstalled = Object.keys(packages).filter(key => packages[key].status === 'uninstalled').map(key => packages[key].package);
    debug('uninstalled', uninstalled);
    const commits = yield doClone(uninstalled, configuration.settings.packages);
    debug('commits', commits);
    console.log('Cloned packages ', commits);
    const instances = yield doInstancesInfo({
      instances: configuration.repository.instances
    });
    const content_packages = instances[configuration.settings.instance].content.packages;
    debug('content_packages', content_packages); // Install packages

    const installed = yield installPackages({
      pkgs: content_packages,
      repository: configuration.settings.config.replace('/content.yml', '')
    });
    debug('installed', installed);
    const installed_packages = yield doInstancesInfo({
      instances: configuration.repository.instances
    });
    debug('installed_packages', installed_packages); // Deploy symlinks.
    // TODO: async/await
    // TODO: Move to workspace

    Object.keys(installed_packages[configuration.settings.instance].content.packages).forEach(key => {
      debug('installed_packages[configuration.settings.instance].content.packages[key]', installed_packages[configuration.settings.instance].content.packages[key]);
      Object.keys(installed_packages[configuration.settings.instance].content.packages[key].workspace).reduce((acc, workspace) => acc.includes(workspace.split('/')[0]) ? acc : [...acc, workspace], []).filter(group => installed_packages[configuration.settings.instance].content.packages[key].workspace[group].start).forEach(group => {
        debug('link', path.join(configuration.settings.packages, key, installed_packages[configuration.settings.instance].content.packages[key].workspace[group].source || 'content'));
        debug('to', group);

        try {
          fs.ensureSymlinkSync(path.join(configuration.settings.packages, key, installed_packages[configuration.settings.instance].content.packages[key].workspace[group].source || 'content'), path.join(current, group));
          console.log('Symlinked', path.join(configuration.settings.packages, key, installed_packages[configuration.settings.instance].content.packages[key].workspace[group].source || 'content') + ' to ' + path.join(current, group));
        } catch (e) {
          exit('\nError while creating symlink from ' + path.join(configuration.settings.packages, key, installed_packages[configuration.settings.instance].content.packages[key].workspace[group].source || 'content') + ' to ' + path.join(current, group), e);
        }
      });
    });
    return configuration;
  });

  return function doPackagesInit(_x8) {
    return _ref8.apply(this, arguments);
  };
}();

exports.doPackagesInit = doPackagesInit;
//# sourceMappingURL=package.js.map