"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doLoad = exports.doNew = void 0;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const debug = require('debug')('docsmith:store');

const fs = require('fs-extra');

const read = require('fs').readFileSync;

const path = require('path');

const omit = require('lodash').omit;

const yaml = require('js-yaml');

global.Promise = require('bluebird');
global.Promise.promisifyAll(fs);

const chalk = require('chalk');

const configure = require('./configure');

const _require = require('./utils/git'),
      doCheck = _require.doCheck,
      doClone = _require.doClone,
      doInfo = _require.doInfo;

const _require2 = require('./workspace'),
      doWorkspaceCheck = _require2.doWorkspaceCheck;

const settings = require('./utils/settings'); // Default to creating global ~/.content and link it to current workspace. (Using this as a workspace detection feature).
// Register workspace in `.content/content.yml` file.
// Allow multi configuration (for development, isolation) by reading the relative `.content` folder.
// `configure`: Check if configure. Creates .content and clone, and checks out tag.
// `store/create`: Creates and checks out new personal work branch
// `package/check`: Checks npm for new release.
// `store/update`: Asks for update (rebase).
// `configure/default`: Ask to make default


const doNew = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* ({
    name,
    template,
    branch,
    configuration
  }) {
    if (!configuration) {
      configuration = yield configure.doGet();
    } // Does name exist?
    //   - if yes, then output with a message.

  });

  return function doNew(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.doNew = doNew;

const doLoad = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(function* ({
    name,
    branch
  }) {// Does name exist?
    //   - if not, then output with a message
    // Does branch exit?
    //   - if not, output with a message
  });

  return function doLoad(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

exports.doLoad = doLoad;
//# sourceMappingURL=store.js.map